|
|
04161d |
From bb0e7fabcaed9a7e71e30f05e638e9f243cdb13e Mon Sep 17 00:00:00 2001
|
|
|
04161d |
From: =?UTF-8?q?P=C3=A1draig=20Brady?= <P@draigBrady.com>
|
|
|
04161d |
Date: Mon, 25 Jan 2021 14:12:48 +0000
|
|
|
04161d |
Subject: [PATCH] split: fix --number=K/N to output correct part of file
|
|
|
04161d |
|
|
|
04161d |
This functionality regressed with the adjustments
|
|
|
04161d |
in commit v8.25-4-g62e7af032
|
|
|
04161d |
|
|
|
04161d |
* src/split.c (bytes_chunk_extract): Account for already read data
|
|
|
04161d |
when seeking into the file.
|
|
|
04161d |
* tests/split/b-chunk.sh: Use the hidden ---io-blksize option,
|
|
|
04161d |
to test this functionality.
|
|
|
04161d |
Fixes https://bugs.gnu.org/46048
|
|
|
04161d |
|
|
|
04161d |
Upstream-commit: bb21daa125aeb4e32546309d370918ca47e612db
|
|
|
04161d |
Signed-off-by: Kamil Dudka <kdudka@redhat.com>
|
|
|
04161d |
---
|
|
|
04161d |
src/split.c | 2 +-
|
|
|
04161d |
tests/split/b-chunk.sh | 45 ++++++++++++++++++++++++------------------
|
|
|
04161d |
2 files changed, 27 insertions(+), 20 deletions(-)
|
|
|
04161d |
|
|
|
04161d |
diff --git a/src/split.c b/src/split.c
|
|
|
04161d |
index 09e610b..19248f6 100644
|
|
|
04161d |
--- a/src/split.c
|
|
|
04161d |
+++ b/src/split.c
|
|
|
04161d |
@@ -1001,7 +1001,7 @@ bytes_chunk_extract (uintmax_t k, uintmax_t n, char *buf, size_t bufsize,
|
|
|
04161d |
}
|
|
|
04161d |
else
|
|
|
04161d |
{
|
|
|
04161d |
- if (lseek (STDIN_FILENO, start, SEEK_CUR) < 0)
|
|
|
04161d |
+ if (lseek (STDIN_FILENO, start - initial_read, SEEK_CUR) < 0)
|
|
|
04161d |
die (EXIT_FAILURE, errno, "%s", quotef (infile));
|
|
|
04161d |
initial_read = SIZE_MAX;
|
|
|
04161d |
}
|
|
|
04161d |
diff --git a/tests/split/b-chunk.sh b/tests/split/b-chunk.sh
|
|
|
04161d |
index 864ce55..39a6799 100755
|
|
|
04161d |
--- a/tests/split/b-chunk.sh
|
|
|
04161d |
+++ b/tests/split/b-chunk.sh
|
|
|
04161d |
@@ -35,32 +35,39 @@ split -e -n 10 /dev/null || fail=1
|
|
|
04161d |
returns_ 1 stat x?? 2>/dev/null || fail=1
|
|
|
04161d |
|
|
|
04161d |
printf '1\n2\n3\n4\n5\n' > input || framework_failure_
|
|
|
04161d |
+printf '1\n2' > exp-1 || framework_failure_
|
|
|
04161d |
+printf '\n3\n' > exp-2 || framework_failure_
|
|
|
04161d |
+printf '4\n5\n' > exp-3 || framework_failure_
|
|
|
04161d |
|
|
|
04161d |
for file in input /proc/version /sys/kernel/profiling; do
|
|
|
04161d |
test -f $file || continue
|
|
|
04161d |
|
|
|
04161d |
- split -n 3 $file > out || fail=1
|
|
|
04161d |
- split -n 1/3 $file > b1 || fail=1
|
|
|
04161d |
- split -n 2/3 $file > b2 || fail=1
|
|
|
04161d |
- split -n 3/3 $file > b3 || fail=1
|
|
|
04161d |
+ for blksize in 1 2 4096; do
|
|
|
04161d |
+ if ! test "$file" = 'input'; then
|
|
|
04161d |
+ # For /proc like files we must be able to read all
|
|
|
04161d |
+ # into the internal buffer to be able to determine size.
|
|
|
04161d |
+ test "$blksize" = 4096 || continue
|
|
|
04161d |
+ fi
|
|
|
04161d |
|
|
|
04161d |
- case $file in
|
|
|
04161d |
- input)
|
|
|
04161d |
- printf '1\n2' > exp-1
|
|
|
04161d |
- printf '\n3\n' > exp-2
|
|
|
04161d |
- printf '4\n5\n' > exp-3
|
|
|
04161d |
+ split -n 3 ---io-blksize=$blksize $file > out || fail=1
|
|
|
04161d |
+ split -n 1/3 ---io-blksize=$blksize $file > b1 || fail=1
|
|
|
04161d |
+ split -n 2/3 ---io-blksize=$blksize $file > b2 || fail=1
|
|
|
04161d |
+ split -n 3/3 ---io-blksize=$blksize $file > b3 || fail=1
|
|
|
04161d |
|
|
|
04161d |
- compare exp-1 xaa || fail=1
|
|
|
04161d |
- compare exp-2 xab || fail=1
|
|
|
04161d |
- compare exp-3 xac || fail=1
|
|
|
04161d |
- ;;
|
|
|
04161d |
- esac
|
|
|
04161d |
+ case $file in
|
|
|
04161d |
+ input)
|
|
|
04161d |
+ compare exp-1 xaa || fail=1
|
|
|
04161d |
+ compare exp-2 xab || fail=1
|
|
|
04161d |
+ compare exp-3 xac || fail=1
|
|
|
04161d |
+ ;;
|
|
|
04161d |
+ esac
|
|
|
04161d |
|
|
|
04161d |
- compare xaa b1 || fail=1
|
|
|
04161d |
- compare xab b2 || fail=1
|
|
|
04161d |
- compare xac b3 || fail=1
|
|
|
04161d |
- cat xaa xab xac | compare - $file || fail=1
|
|
|
04161d |
- test -f xad && fail=1
|
|
|
04161d |
+ compare xaa b1 || fail=1
|
|
|
04161d |
+ compare xab b2 || fail=1
|
|
|
04161d |
+ compare xac b3 || fail=1
|
|
|
04161d |
+ cat xaa xab xac | compare - $file || fail=1
|
|
|
04161d |
+ test -f xad && fail=1
|
|
|
04161d |
+ done
|
|
|
04161d |
done
|
|
|
04161d |
|
|
|
04161d |
Exit $fail
|
|
|
04161d |
--
|
|
|
04161d |
2.26.2
|
|
|
04161d |
|